%define anolis_release 4
Name: glib2
Version: 2.78.3
Release: %{anolis_release}%{?dist}
Summary: A library of handy utility functions

License: LGPLv2+
URL: https://www.gtk.org
Source0: https://download.gnome.org/sources/glib/2.78/glib-%{version}.tar.xz

# Reference to https://gitlab.gnome.org/GNOME/glib/-/commit/c9b03bdb7ca9283e4ff6ab809dab04436332b611
Patch1001:     1001-Backport-patch-to-fix-CVE-2025-3360.patch
# Reference to https://gitlab.gnome.org/GNOME/glib/-/commit/25833cefda24c60af913d6f2d532b5afd608b821
Patch1002:     1002-Backport-patch-to-fix-CVE-2024-52533.patch

BuildRequires: gcc meson >= 0.60.0 gettext gtk-doc perl-interpreter glibc-devel
BuildRequires: systemtap-sdt-devel zlib-devel python3-devel
BuildRequires: bash-completion >= 2.0 elfutils-libelf-devel libffi-devel >= 3.0.0
BuildRequires: pcre2-devel >= 10.32 libselinux-devel >= 2.2
BuildRequires: libmount-devel >= 2.23 sysprof-capture-devel >= 3.38.0

Obsoletes: %{name}-fam < 2.67.1-3

Provides: bundled(gnulib) bundled(gvdb) bundled(libcharset) bundled(xdgmime)

%description
GLib is a general-purpose, portable utility library that provides many useful
data types, macros, type conversions, string utilities, file utilities, a
mainloop abstraction and more. It is a low-level core library that forms the
basis for projects such as GTK+ and GNOME. GLib provides data structure
handling for C, portability wrappers, and interfaces for such runtime
functionality as an event loop, threads, dynamic loading, and an object system.

%package devel
Summary: subpackage for development purpose
Requires: %{name} = %{version}-%{release}

%description devel
The %{name}-devel subpackage includes the header files for the GLib library.

%package static
Summary: subpackage of static library files
Requires: %{name}-devel = %{version}-%{release}

%description static
The %{name}-static subpackage contains static libraries for %{name}.

%package tests
Summary: subpackage of tests for the %{name} package
Requires: %{name} = %{version}-%{release}

%description tests
The %{name}-tests subpackage contains tests that can be used to verify
the functionality of the installed %{name} package.

%package doc
Summary: subpackage of %{name} documentation
Requires: %{name} = %{version}-%{release}
BuildArch: noarch

%description doc
The %{name}-doc subpackage includes documentation for the GLib library.

%prep
%autosetup -n glib-%{version} -p1

%build
%meson --default-library=both -Dglib_debug=disabled -Dinstalled_tests=true \
    -Dman=true -Dgtk_doc=true -Dsysprof=enabled -Ddtrace=true -Dsystemtap=true
%meson_build

%install
%meson_install
touch -r gio/gdbus-2.0/codegen/config.py.in %{buildroot}%{_datadir}/glib-2.0/codegen/*.py
%py_byte_compile %{python3} %{buildroot}%{_datadir}

mkdir -p %{buildroot}%{_libdir}/gio/modules
touch %{buildroot}%{_libdir}/gio/modules/giomodule.cache

%find_lang glib20

%transfiletriggerpostun -- %{_libdir}/gio/modules
%{_bindir}/gio-querymodules %{_libdir}/gio/modules &> /dev/null || :

%transfiletriggerin -- %{_libdir}/gio/modules
%{_bindir}/gio-querymodules %{_libdir}/gio/modules &> /dev/null || :

%transfiletriggerpostun -- %{_datadir}/glib-2.0/schemas
%{_bindir}/glib-compile-schemas %{_datadir}/glib-2.0/schemas &> /dev/null || :

%transfiletriggerin -- %{_datadir}/glib-2.0/schemas
%{_bindir}/glib-compile-schemas %{_datadir}/glib-2.0/schemas &> /dev/null || :

%files -f glib20.lang
%license COPYING
%{_libdir}/libgmodule-2.0.so.*
%{_libdir}/libgobject-2.0.so.*
%{_libdir}/libglib-2.0.so.*
%{_libdir}/libgthread-2.0.so.*
%{_libdir}/libgio-2.0.so.*
%dir %{_datadir}/bash-completion
%dir %{_datadir}/bash-completion/completions
%{_datadir}/bash-completion/completions/{gapplication,gsettings,gdbus,gio}
%dir %{_datadir}/glib-2.0
%dir %{_datadir}/glib-2.0/schemas
%dir %{_libdir}/gio
%dir %{_libdir}/gio/modules
%ghost %{_libdir}/gio/modules/giomodule.cache
%{_bindir}/{gsettings,gio,glib-compile-schemas,gapplication,gdbus,gio-querymodules}
%{_libexecdir}/gio-launch-desktop
%{_mandir}/man1/glib-compile-schemas.1*
%{_mandir}/man1/gio.1*
%{_mandir}/man1/gio-querymodules.1*
%{_mandir}/man1/gapplication.1*
%{_mandir}/man1/gsettings.1*
%{_mandir}/man1/gdbus.1*

%files devel
%{_libdir}/lib*.so
%{_libdir}/glib-2.0
%{_includedir}/*
%{_datadir}/aclocal/*
%{_libdir}/pkgconfig/*
%{_datadir}/glib-2.0/gdb
%{_datadir}/glib-2.0/gettext
%{_datadir}/glib-2.0/dtds/gresource.dtd
%{_datadir}/glib-2.0/schemas/gschema.dtd
%{_datadir}/glib-2.0/valgrind/glib.supp
%{_datadir}/bash-completion/completions/gresource
%{_bindir}/{gobject-query,glib-gettextize,gtester,glib-compile-resources}
%{_bindir}/{glib-genmarshal,gdbus-codegen,glib-mkenums,gresource}
%{_datadir}/glib-2.0/codegen
%attr (0755, root, root) %{_bindir}/gtester-report
%{_mandir}/man1/glib-gettextize.1*
%{_mandir}/man1/gtester.1*
%{_mandir}/man1/glib-compile-resources.1*
%{_mandir}/man1/gresource.1*
%{_mandir}/man1/gtester-report.1*
%{_mandir}/man1/gobject-query.1*
%{_mandir}/man1/glib-genmarshal.1*
%{_mandir}/man1/glib-mkenums.1*
%{_mandir}/man1/gdbus-codegen.1*
%{_datadir}/systemtap/
%{_datadir}/gdb/
%{_datadir}/gettext/

%files static
%{_libdir}/{libgio-2.0.a,libgobject-2.0.a,libgthread-2.0.a,libglib-2.0.a,libgmodule-2.0.a}

%files tests
%{_datadir}/installed-tests
%{_libexecdir}/installed-tests

%files doc
%{_datadir}/gtk-doc/
%doc NEWS README.md

%changelog
* Tue May 06 2025 Cheng Yang <yc02267530@alibaba-inc.com> - 2.78.3-4
- Fix CVE-2024-52533

* Sun Apr 27 2025 Chang Gao <gc-taifu@linux.alibaba.com> - 2.78.3-3
- Fix CVE-2025-3360

* Mon Apr 01 2024 Bo Ren <rb01097748@alibaba-inc.com> - 2.78.3-2
- add changelog

* Fri Mar 15 2024 Zhenyu Wang <wang.zhenyu5@zte.com.cn> - 2.78.3-1
- init from upstream 2.78.3

* Mon Jul 10 2023 Funda Wang <fundawang@yeah.net> - 2.76.4-1
- New version 2.76.4

* Wed May 24 2023 Funda Wang <fundawang@yeah.net> - 2.76.3-1
- New version 2.76.3

* Sat Apr 22 2023 Funda Wang <fundawang@yeah.net> - 2.76.2-1
- New version 2.76.2

* Mon Apr 10 2023 Zhongling <zhonglingh@linux.alibaba.com> - 2.76.1-2
- Refactor rpm spec

* Fri Mar 24 2023 Funda Wang <fundawang@yeah.net> - 2.76.1-1
- New version 2.76.1

* Sat Mar 11 2023 Funda Wang <fundawang@yeah.net> - 2.76.0-1
- New version 2.76.0

* Fri Feb 24 2023 Funda Wang <fundawang@yeah.net> - 2.74.6-1
- New version 2.74.6

* Sat Jan 21 2023 Funda Wang <fundawang@yeah.net> - 2.74.5-1
- New version 2.74.5
- Drop workaround for multi-lib as anolis 23 does not support
  32-bit environment even after enabling loongarch64

* Thu Dec 22 2022 Funda Wang <fundawang@yeah.net> - 2.74.4-1
- New version 2.74.4

* Fri Dec 2 2022 Funda Wang <fundawang@yeah.ent> - 2.74.3-1
- New version 2.74.3

* Sat Nov 26 2022 Funda Wang <fundawang@yeah.net> - 2.74.2-1
- New version 2.74.2

* Wed Nov 23 2022 Funda Wang <fundawang@yeah.net> - 2.74.1-1
- New version 2.74.1
- Drop gnutls-hmac patch as it won't be accepted upstream

* Mon Aug 15 2022 mgb01105731 <mgb01105731@alibaba-inc.com> - 2.73.2-1
- update to 2.73.2
- Replace pcre to pcre2

* Fri Mar 18 2022 Chunmei Xu <xuchunmei@linux.alibaba.com> - 2.72.0-1
- update to 2.72.0

* Tue Mar 08 2022 Chunmei Xu <xuchunmei@linux.alibaba.com> 2.71.1-1
- init from upstream 2.71.1
- add gnutls-hmac.patch for backend compat
